/*
 * $Id$
 */

package org.apache.maven.plugin.verifier.model.io.xpp3;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.io.Writer;
import java.util.Iterator;
import org.apache.maven.plugin.verifier.model.File;
import org.apache.maven.plugin.verifier.model.Verifications;
import org.codehaus.plexus.util.xml.pull.*;

/**
 * Class VerificationsXpp3Writer.
 * 
 * @version $Revision$ $Date$
 */
public class VerificationsXpp3Writer {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field serializer
     */
    private org.codehaus.plexus.util.xml.pull.XmlSerializer serializer;

    /**
     * Field NAMESPACE
     */
    private String NAMESPACE;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method write
     * 
     * @param writer
     * @param verifications
     */
    public void write(Writer writer, Verifications verifications)
        throws java.io.IOException
    {
        serializer = new MXSerializer();
        serializer.setProperty( "http://xmlpull.org/v1/doc/properties.html#serializer-indentation", "  " );
        serializer.setProperty( "http://xmlpull.org/v1/doc/properties.html#serializer-line-separator", "\n" );
        serializer.setOutput( writer );
        serializer.startDocument( verifications.getModelEncoding(), null );
        writeVerifications( verifications, "verifications", serializer );
        serializer.endDocument();
    } //-- void write(Writer, Verifications) 

    /**
     * Method writeFile
     * 
     * @param file
     * @param serializer
     * @param tagName
     */
    private void writeFile(File file, String tagName, XmlSerializer serializer)
        throws java.io.IOException
    {
        if ( file != null )
        {
            serializer.startTag( NAMESPACE, tagName );
            if ( file.getLocation() != null )
            {
                serializer.startTag( NAMESPACE, "location" ).text( file.getLocation() ).endTag( NAMESPACE, "location" );
            }
            if ( file.getContains() != null )
            {
                serializer.startTag( NAMESPACE, "contains" ).text( file.getContains() ).endTag( NAMESPACE, "contains" );
            }
            if ( file.isExists() != true )
            {
                serializer.startTag( NAMESPACE, "exists" ).text( String.valueOf( file.isExists() ) ).endTag( NAMESPACE, "exists" );
            }
            serializer.endTag( NAMESPACE, tagName );
        }
    } //-- void writeFile(File, String, XmlSerializer) 

    /**
     * Method writeVerifications
     * 
     * @param verifications
     * @param serializer
     * @param tagName
     */
    private void writeVerifications(Verifications verifications, String tagName, XmlSerializer serializer)
        throws java.io.IOException
    {
        if ( verifications != null )
        {
            serializer.startTag( NAMESPACE, tagName );
            if ( verifications.getFiles() != null && verifications.getFiles().size() > 0 )
            {
                serializer.startTag( NAMESPACE, "files" );
                for ( Iterator iter = verifications.getFiles().iterator(); iter.hasNext(); )
                {
                    File o = (File) iter.next();
                    writeFile( o, "file", serializer );
                }
                serializer.endTag( NAMESPACE, "files" );
            }
            serializer.endTag( NAMESPACE, tagName );
        }
    } //-- void writeVerifications(Verifications, String, XmlSerializer) 

}
