/*
 * $Id$
 */

package org.apache.maven.model;

/**
 * null
 * 
 * @version $Revision$ $Date$
 */
public class Build extends BuildBase 
implements java.io.Serializable
{


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field sourceDirectory
     */
    private String sourceDirectory;

    /**
     * Field scriptSourceDirectory
     */
    private String scriptSourceDirectory;

    /**
     * Field testSourceDirectory
     */
    private String testSourceDirectory;

    /**
     * Field outputDirectory
     */
    private String outputDirectory;

    /**
     * Field testOutputDirectory
     */
    private String testOutputDirectory;

    /**
     * Field extensions
     */
    private java.util.List extensions;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addExtension
     * 
     * @param extension
     */
    public void addExtension(Extension extension)
    {
        getExtensions().add( extension );
    } //-- void addExtension(Extension) 

    /**
     * Method getExtensions
     */
    public java.util.List getExtensions()
    {
        if ( this.extensions == null )
        {
            this.extensions = new java.util.ArrayList();
        }
        
        return this.extensions;
    } //-- java.util.List getExtensions() 

    /**
     * Get 
     *             The directory where compiled application classes
     * are placed.
     *           
     */
    public String getOutputDirectory()
    {
        return this.outputDirectory;
    } //-- String getOutputDirectory() 

    /**
     * Get 
     *             This element specifies a directory containing
     * the script sources
     *             of the project. This directory is meant to be
     * different from the
     *             sourceDirectory, in that its contents will be
     * copied to the output
     *             directory in most cases (since scripts are
     * interpreted rather than
     *             compiled).
     *           
     */
    public String getScriptSourceDirectory()
    {
        return this.scriptSourceDirectory;
    } //-- String getScriptSourceDirectory() 

    /**
     * Get 
     *             This element specifies a directory containing
     * the source
     *             of the project. The generated build system will
     * compile
     *             the source in this directory when the project is
     * built.
     *             The path given is relative to the project
     * descriptor.
     *           
     */
    public String getSourceDirectory()
    {
        return this.sourceDirectory;
    } //-- String getSourceDirectory() 

    /**
     * Get 
     *             The directory where compiled test classes are
     * placed.
     *           
     */
    public String getTestOutputDirectory()
    {
        return this.testOutputDirectory;
    } //-- String getTestOutputDirectory() 

    /**
     * Get 
     *             This element specifies a directory containing
     * the unit test
     *             source of the project. The generated build
     * system will
     *             compile these directories when the project is
     * being tested.
     *             The path given is relative to the project
     * descriptor.
     *           
     */
    public String getTestSourceDirectory()
    {
        return this.testSourceDirectory;
    } //-- String getTestSourceDirectory() 

    /**
     * Method removeExtension
     * 
     * @param extension
     */
    public void removeExtension(Extension extension)
    {
        getExtensions().remove( extension );
    } //-- void removeExtension(Extension) 

    /**
     * Set A set of build extensions to use from this project.
     * 
     * @param extensions
     */
    public void setExtensions(java.util.List extensions)
    {
        this.extensions = extensions;
    } //-- void setExtensions(java.util.List) 

    /**
     * Set 
     *             The directory where compiled application classes
     * are placed.
     *           
     * 
     * @param outputDirectory
     */
    public void setOutputDirectory(String outputDirectory)
    {
        this.outputDirectory = outputDirectory;
    } //-- void setOutputDirectory(String) 

    /**
     * Set 
     *             This element specifies a directory containing
     * the script sources
     *             of the project. This directory is meant to be
     * different from the
     *             sourceDirectory, in that its contents will be
     * copied to the output
     *             directory in most cases (since scripts are
     * interpreted rather than
     *             compiled).
     *           
     * 
     * @param scriptSourceDirectory
     */
    public void setScriptSourceDirectory(String scriptSourceDirectory)
    {
        this.scriptSourceDirectory = scriptSourceDirectory;
    } //-- void setScriptSourceDirectory(String) 

    /**
     * Set 
     *             This element specifies a directory containing
     * the source
     *             of the project. The generated build system will
     * compile
     *             the source in this directory when the project is
     * built.
     *             The path given is relative to the project
     * descriptor.
     *           
     * 
     * @param sourceDirectory
     */
    public void setSourceDirectory(String sourceDirectory)
    {
        this.sourceDirectory = sourceDirectory;
    } //-- void setSourceDirectory(String) 

    /**
     * Set 
     *             The directory where compiled test classes are
     * placed.
     *           
     * 
     * @param testOutputDirectory
     */
    public void setTestOutputDirectory(String testOutputDirectory)
    {
        this.testOutputDirectory = testOutputDirectory;
    } //-- void setTestOutputDirectory(String) 

    /**
     * Set 
     *             This element specifies a directory containing
     * the unit test
     *             source of the project. The generated build
     * system will
     *             compile these directories when the project is
     * being tested.
     *             The path given is relative to the project
     * descriptor.
     *           
     * 
     * @param testSourceDirectory
     */
    public void setTestSourceDirectory(String testSourceDirectory)
    {
        this.testSourceDirectory = testSourceDirectory;
    } //-- void setTestSourceDirectory(String) 


    private String modelEncoding = "UTF-8";

    public void setModelEncoding( String modelEncoding )
    {
        this.modelEncoding = modelEncoding;
    }

    public String getModelEncoding()
    {
        return modelEncoding;
    }}
