/*
 * $Id$
 */

package org.apache.maven.plugin.tools.model;

/**
 * 
 *       	A sub-process execution of a lifecycle to satisfy the
 * needs of a mojo.
 *       
 * 
 * @version $Revision$ $Date$
 */
public class LifecycleExecution implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field lifecycle
     */
    private String lifecycle;

    /**
     * Field phase
     */
    private String phase;

    /**
     * Field goal
     */
    private String goal;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Get A goal, not attached to a lifecycle phase, which should
     * be executed ahead of this mojo.
     */
    public String getGoal()
    {
        return this.goal;
    } //-- String getGoal() 

    /**
     * Get The name of the overlay to apply to the sub-lifecycle
     * before executing it. If specified, this lifecycle overlay
     * definition will be bundled with the plugin.
     */
    public String getLifecycle()
    {
        return this.lifecycle;
    } //-- String getLifecycle() 

    /**
     * Get The phase in the sub-lifecycle.
     */
    public String getPhase()
    {
        return this.phase;
    } //-- String getPhase() 

    /**
     * Set A goal, not attached to a lifecycle phase, which should
     * be executed ahead of this mojo.
     * 
     * @param goal
     */
    public void setGoal(String goal)
    {
        this.goal = goal;
    } //-- void setGoal(String) 

    /**
     * Set The name of the overlay to apply to the sub-lifecycle
     * before executing it. If specified, this lifecycle overlay
     * definition will be bundled with the plugin.
     * 
     * @param lifecycle
     */
    public void setLifecycle(String lifecycle)
    {
        this.lifecycle = lifecycle;
    } //-- void setLifecycle(String) 

    /**
     * Set The phase in the sub-lifecycle.
     * 
     * @param phase
     */
    public void setPhase(String phase)
    {
        this.phase = phase;
    } //-- void setPhase(String) 


    private String modelEncoding = "UTF-8";

    public void setModelEncoding( String modelEncoding )
    {
        this.modelEncoding = modelEncoding;
    }

    public String getModelEncoding()
    {
        return modelEncoding;
    }}
